/*
# Dieses Dokument ist in der Zusammenarbeit von Informatikreferendaren und
# ehemaligen Informatikreferendaren der Studienseminare (heute ZfsL) Arnsberg,
# Hamm und Solingen entstanden.
#
# Das Dokument steht unter der Lizenz: Creative Commons by-nc-sa Version 4.0
# http://creativecommons.org/licenses/by-nc-sa/4.0/deed.de
#
# Nach dieser Lizenz darf das Dokument beliebig kopiert und bearbeitet werden,
# sofern das Folgeprodukt wiederum unter gleichen Lizenzbedingungen vertrieben
# und auf die ursprünglichen Urheber verwiesen wird.
# Eine kommerzielle Nutzung ist ausdrücklich ausgeschlossen.
#
# Die Namensnennung durch einen Verweis und die Lizenzangabe der ursprünglichen
# Urheber auf den Materialien für Schülerinnen und Schüler ist erforderlich.
#
# Die Sammlung der Dokumente steht unter
# http://ddi.uni-wuppertal.de/material/materialsammlung/
# zur Verfügung.
*/

class DummyAlarmanlageStatus implements AlarmanlageModelInterface, AlarmanlageAlarmInterface, AlarmanlageStatusInterface {
    def active = false
    def alarm = false
    def events = 0
    def random = new Random()

    def event(name, value) {
        //Aktivschaltung
        if (name == "active") {
            if (value instanceof String && value == "switch") {
                this.active = !this.active
                //println("Status umgeschaltet")
            } else {
                this.active = value
            }
            if (!this.active) {
                this.alarm = false
                this.events = 0
            }
        }
        //Auslösen eines Sensors
        if (name == "sensor") {
            if (value instanceof String && value == "registerEvent" && this.active) {
                this.events++
            }
            if (this.events > 3) {
                this.alarm = true
                //println("Alarm gegeben")
            }
        }
    }

    def isActive() {
        return this.active
    }

    def isTriggered() {
        return this.alarm
    }
}
